#include "text.h"
#include <iostream>
#include <vector>
using namespace std;

void show_histogram_text(const vector<size_t>& bins) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    int max_count = 0;
    for (int count : bins) {
        if (count > max_count) max_count = count;
    }

    for (size_t j = 0; j < bins.size(); j++) {
        if (bins[j] < 100) cout << " ";
        if (bins[j] < 10) cout << " ";
        cout << bins[j] << "|";

        size_t height = bins[j];
        if (max_count > MAX_ASTERISK) {
            if (max_count != bins[j]) {
                height = static_cast<size_t>(MAX_ASTERISK * (static_cast<float>(bins[j]) / max_count));
            }
            else if (max_count == bins[j]) {
                height = MAX_ASTERISK;
            }
        }

        for (size_t i = 0; i < height; i++) cout << "*";
        cout << "\n";
    }
}
